*! version 1.0 -- 12/11/07 -- pbe
program ctems
version 10

syntax , Index(string) Levels(string) Random(string) [ Comment(string) ]

keep effect subscript
local sps " + "
local us "_"
local lmodelr "mu + "
tempvar parenl parenr parend rsub paren tvar slen

quietly {
  gen `parenl'=strpos(subscript,"(")
  gen `parenr'=strpos(subscript,")")
  gen `parend'=`parenr'-`parenl'-1
  gen `rsub'=substr(subscript,1,`parenl'-1)
  replace `rsub'=subscript if `parenl'==0
  gen `paren'=substr(subscript,`parenl'+1,`parend') if `parenl'>0
  /* gen `slen' = length(`rsub')+length(`paren')
  sort `slen', stable */
}

/* create index variables */
foreach var in `index' {
  quietly gen `var' = .
}

/* values in parentheses */
foreach var in `index' {
  quietly replace `var' = 1 if strpos(`paren',"`var'")>0
}

/* set char for levels & random */
tokenize `levels'
local i=0
foreach var in `index' {
  local i=`i'+1
  char `var'[levels] ``i''
}
tokenize `random'
local i=0
foreach var in `index' {
  local i=`i'+1
  char `var'[random] ``i''
}

/* column heading not in subscript */
foreach var in `index' {
  local mname : char `var'[levels]
  quietly replace `var'=real("`mname'") if strpos(`rsub',"`var'")==0 & `var'==.
}

/* column heading in subscript */
foreach var in `index' {
  local mname : char `var'[random]
  quietly replace `var'=real("`mname'") if `var'==.
}


local N=_N
quietly gen ems=""

forvalues i=1/`N' {
  local emsstr ""

  forvalues j=`N'(-1)`i' {
  local strtemp ""
  local coef=1
  if indexnot(subscript[`i'],subscript[`j'])==0 { 
    foreach var in `index' {
      if strpos(subscript[`i'],"`var'")==0 {
        local coef=`coef'*`var'[`j']
      }
    }
  
   local strtemp=string(`coef')+effect[`j']
    if `coef'~=0 {
      local emsstr="`emsstr'" + "`strtemp'" + "`sps'"
    }
  }
 quietly replace ems="`emsstr'" in `i'
  }
}
/* remove trailing + */
quietly replace ems=substr(ems,1,length(ems)-2)
/* remove coefficient 1 before e */
quietly replace ems=subinstr(ems,"1e","e",1)

forvalues i = 1/`N' {
  local lmodelr = "`lmodelr'"+effect[`i']+"`us'"+subscript[`i']+"`sps'"
}
local lmodelr = substr("`lmodelr'",1,length("`lmodelr'")-2)

format ems %-80s
format subscript %12s
local rhs "`index'"
local rhs = subinstr("`rhs'"," ","",.)
display "`rhs'"
display
display as txt "Linear Model:"
display as txt "Y_`rhs' = `lmodelr'"

list effect subscript ems, separator(0) abbr(10)

if "`comment'"~="" {
  display
  display as txt "`comment'"
}


end
